#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>


#define BACKLOG 10
#define MAXBUFLEN 30
#define MAXNICKLEN 20

#define WRITELOG 1

/*
typedef struct{

	string id;
	string description;
	string location;
	string summary;

	int priority;
	int status;
	int endDate;
	int startDate;
	int createdTime;
}MyEvent;
*/

int serverSetup( int* pfd, struct sockaddr_in* paddr_my, int myport ){

	/* create a TCP socket */
	if ((*pfd=socket(AF_INET,SOCK_STREAM,0)) < 0) {
		perror("socket");
		exit(1);
	}

	u_int yes=1;
	/* allow multiple sockets to use the same PORT number */
	if ( setsockopt( *pfd, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(yes) ) < 0 ) {
		perror("Reusing ADDR failed");
		exit(1);
	}

	/* set up host address */
	memset(paddr_my,0,sizeof(*paddr_my));
	(*paddr_my).sin_family=AF_INET;
	(*paddr_my).sin_addr.s_addr=htonl(INADDR_ANY);
	(*paddr_my).sin_port=htons(myport);

	/* bind to receive address */
	if (bind(*pfd,(struct sockaddr *) paddr_my,sizeof(*paddr_my)) < 0) {
		perror("bind");
		exit(1);
	}else if(WRITELOG)printf("binding done.\n");

	  return 0;
}

void connectClient(int* psockfd, unsigned short client_port, struct in_addr * inAddr, struct  sockaddr_in* _ptheir_addr ){

  //create a socket
  if (  ( (*psockfd) = socket(AF_INET, SOCK_STREAM, 0) ) == -1  ) {
    perror("socket error");
    exit(1);
  }//else printf("socket made\n");
  printf( "connecting... sock:%i \n" , (*psockfd) );

  //setup server address
    struct sockaddr_in* their_addr;
  (*their_addr).sin_family = AF_INET;			 	// host byte order

  //connect with the client - as this is tcp
  if( connect( (*psockfd), (struct sockaddr *)their_addr, sizeof(struct sockaddr) ) == -1 ){
      perror("Client-connect() error");
      exit(1);
  }else printf("connected to server.\n");

 printf( "im here3" );
}

//Get data from the specified socket fd
//REF: http://www.tenouk.com/Module40a.html
int readData(int fd, char buf[]){

	if(WRITELOG)printf("in read\n");
	int recivedBytes = -1;
	char* pBuf = buf;
	if( (recivedBytes = recv(fd, buf, MAXBUFLEN,0) ) > 0 ){
		pBuf += recivedBytes;
	}
	if( recivedBytes == 0 )
		return -1;
	*pBuf = '\0';
	if(WRITELOG)printf("read: %s\n",buf);

	return recivedBytes;
}

//For sending the data to specified socket fd
int writeData(int fd,char msg[]){

//  if(WRITELOG)printf("server sending msg\n");
  send (fd, msg, strlen(msg),0);
  if(WRITELOG)printf("server sent msg:%s\n", msg);
}

/*void closeConnection(int clientIndex, int clientFds[], fd_set* pfds){
	//close socket and remove from socket set
	close(clientFds[clientIndex]);
	FD_CLR( clientFds[clientIndex], pfds );
}*/

//function taking care of the select statement logic
int waittoread( fd_set* _fds, int sockfd)
{
   int rc, max;
   fd_set fds;
   memcpy( &fds, _fds, sizeof(*_fds) );	//making a copy so the original is not busy
   max = getdtablesize(); //size of the fd_set for 1st param
   rc = select(max, &fds, NULL, NULL, NULL );

   if (rc==-1) {
      perror("select failed");
      return -1;
   }
   else{
      //check all sockets and return one which is set
      //even though more then one can be set at the same time, we deal with them one by one.
      if( FD_ISSET( sockfd, &fds ) )
    	  return rc;
   }

}

//////////main function//////////
int main( int argc, int argv[] ){

  struct sockaddr_in my_addr;	// my address information
  int myport, sockfd;		//server port and listening socket
  fd_set fds;			

  int clientFd;
  char clientNick[MAXNICKLEN];
  char readBuf[MAXBUFLEN];
  char writeBuf[MAXBUFLEN];  
  myport = 5060;

  int ret = serverSetup( &sockfd, &my_addr, myport );

  if( (ret=listen(sockfd, BACKLOG)) == -1 ){
      perror("listen() error!");
      exit(1);
  }  else  if(WRITELOG) printf("listen ready,ret:%i\n",ret);

  FD_ZERO(&fds);	//initialize fdset to 0 , representing the empty set.
  FD_SET( sockfd, &fds ); //set the fd for listening to connections

  if(WRITELOG)printf("socks set!");

  while( 1 ){

    if( waittoread( &fds, sockfd ) == -1 ){
          exit(1);
    }

    struct sockaddr their_addr;
	int sin_size = sizeof(struct sockaddr_in);

    clientFd = accept( sockfd, &their_addr, &sin_size );

      //set the socket for the new client in fdset
      FD_SET( clientFd, &fds );
      if(WRITELOG)printf( "accept done!newfd is : %i\n", clientFd );

      if( readData( clientFd, readBuf ) == -1 )
	close( clientFd );
      else
	printf( "msg from %s:%s", clientNick, readBuf );

//      MyEvent events;// = new MyEvent;
//	events.summary = "This is the summary of the scheduled task";
//	events.description = "This is the description of the scheduled task";
//	events.location = "at Site D";
	
      strcpy(writeBuf,"This is the summary of the scheduled task~~~This is the description of the scheduled task~~~at Site D");
      writeData(clientFd,writeBuf);
/*
      strcpy(writeBuf,"This is the description of the scheduled task");
      writeData(clientFd,writeBuf);

      strcpy(writeBuf,"at Site D");
      writeData(clientFd,writeBuf);

/*	char buf[30];
	int res = readData(fd, buf);
	event->summary = buf;
	res = readData(fd, buf);
	event->description = buf;
	res = readData(fd, buf);
	event->location = buf;
*/

   }



  close( sockfd ); 
  return 0;
}
